//
// File: LandClass.h
// Created by: chochmah <chochmah@localhost>
// Created on: Sat Aug 30 20:04:54 2003
//

#ifndef _LANDCLASS_H_
#define _LANDCLASS_H_

#include <stdlib.h>
#include <GL/glut.h>
#include <math.h>
#include <stdarg.h>
#include <time.h>
#include "stdio.h"

class LandClass
{
	public:
		LandClass();
		 ~LandClass();
	

bool debugswitch;
void loadgradient(char *fn);
void loadmap();
void CreateNewLandscape(int sizex,int sizey);
void calccolors();
void loadcolormap(char *fn);
void makemidpoints();
void makediscrete();
void loadhighmap(char *fn);
void makeMaiver(int i, int l);
void makefieldnormals();
void savetofile(char *fn);
void calccolor(int i, int l);
GLfloat *gethighnorm(int a,int b, int f);

void loadfromfile(char *fn);
void sethigh(int x,int y,int h);
bool checksethigh(int x,int y,int h);
void makefieldnormal(int i,int l);
void setbarehigh(int x,int y, int z);
void setbarehightotal(int x,int y, int z);
int gethigh(int a,int b);
int gethight1(int a,int b);
int gethight2(int a,int b);
int gethight3(int a,int b);
int gethight4(int a,int b);
int getmphigh(int a,int b);
int getmphight1(int a,int b);
int getmphight2(int a,int b);
int getmphight3(int a,int b);
int getmphight4(int a,int b);
void makemidpoint(int i,int l);
void makeRiver(int i, int l);
void switchwatermask(){underwater=!underwater;}
GLfloat highnorm[1024][1024][4][3];
GLfloat vhighnorm[3];

void Bsethigh(int x,int y,int z) {if ((x<0)||(x>SizeX)||(y<0)||(y>SizeY)) {printf("FATAL ERROR 11 at (%i,%i)\n",x,y);return;}high[x][y]=z;};
int Bgethigh(int x, int y) {if ((x<0)||(x>SizeX)||(y<0)||(y>SizeY)) {printf("FATAL ERROR 12 at (%i,%i)\n",x,y);return(0);}return(high[x][y]);};
int SizeX,SizeY;
float gradient[256][3];
int mphigh[1024][1024];

float col[1024][1024][4][4];
bool watermask[1024][1024][4];
bool bebaut[1024][1024];
bool underwater;

void normalize(GLfloat v[3]);
void ncrossprod(float v1[3], float v2[3], float cp[3]);
void triagnormal(float v1[3], float v2[3], float v3[3], float norm[3]);
void triagnormald(double v1[3], double v2[3], double v3[3], float norm[3]);
	protected:
	int high[1024][1024];	
	
};


#endif	//_LANDCLASS_H_

