//SUPERNODE S1;
// File: RailNetworkClass.h
// Created by: chochmah <chochmah@localhost>
// Created on: Wed Aug  6 16:41:50 2003
//

#ifndef _RAILNETWORKCLASS_H_
#define _RAILNETWORKCLASS_H_
#include <stdio.h>
#include "ZugClass.h"
#include "DepotNodeClass.h"

class RailNetworkClass
{
	public:
	
	RNODE *RailTrackend[1024][1024];
RNODE *RailTrackfirst[1024][1024];
SUPERNODE *supernodelistfirst; // erster und letzter Supernode in der Liste;
SUPERNODE *supernodelistlast;
	TSNODE *firsttrainstation;
TSNODE *lasttrainstation;
DepotNodeClass *depotlistfirst;
DepotNodeClass *depotlistlast;
	
	RailNetworkClass();
	 ~RailNetworkClass();
void BuildSuperNodeDirTree(SUPERNODE *ssNode,int hight);		
SUPERNODE *TraceTrack(int mx,int my,int h,int dir,int counter);
void deletetrack(int x,int y);
void AppendTrack(int i,int l,unsigned char tracktype,int h,bool s1,bool s2,bool notrealtime,bool bahnsteigfirst,bool s1s,bool s2s);
void AppendSuperNode(int i, int l, RNODE *rnode);
TSNODE *AppendTrainStation(int x,int y,int h);
void BuildSuperNodeListFromPoint(int x,int y, bool force,int h,bool fixedhight);
void EraseTrack(RNODE *track,int x,int y);
void BuildSignalNetwork();
void AppendSignalConnection(int indir,int udir,SUPERNODE *oNode,SUPERNODE *sNode);
void SearchSignals(int udir,SUPERNODE *oNode,SUPERNODE *sNode,int dir);
void ReworkSupernode(int i, int l, RNODE *rsNode);
void DeleteSuperNode(int x,int y);
void AppendPlattform(TSNODE *bahnhof,int sx,int sy,int ex,int ey,bool realtime);
void DeleteSuperNode(SUPERNODE *sscanfNode);
void DeleteSuperNodeIfDeathEnd(int h,int x,int y);
void MakeSuperNodeNet();
void DeleteSuperNodes();
void AppendDepot(int x,int y,int h);
void BuildSuperNodeList(int x,int y);
int getcon1(int tracktype);
int getcon2(int tracktype);
bool visitetmode; //frs pathfinding

SUPERNODE *FindNextSupernode(int x, int y,RNODE *track, unsigned char dir);
void MakeSuperNodeNetFromNode(SUPERNODE *sNode);

	protected:
		int leavdir;		
	
};


#endif	//_RAILNETWORKCLASS_H_

