//
// File: TSNODE.h
// Created by: chochmah <chochmah@mitre.localhost.localdomain>
// Created on: Mon Dec 15 00:02:47 2003
//

#ifndef _TSNODE_H_
#define _TSNODE_H_

#include "ONODE.h"
#include "GNODE.h"

struct SUPERNODE;

struct RNODE {
   RNODE *pNext;
   RNODE *pPrev;
   unsigned char tracktype;
   int hight;
   //Signalcode	
   bool signal1;
   bool signal2;
   bool signal1state;
   bool signal2state;
   bool bahnsteig;
};


struct SIGNALSTRUCT {
	SIGNALSTRUCT *pNext;
	SIGNALSTRUCT *pPrev;
	SUPERNODE *sNode;
	int indir;
};

struct SUPERNODE {
   SUPERNODE *pNext;
   SUPERNODE *pPrev;
   SUPERNODE *dir[4][4];
   
   unsigned char sdir[4];
   SIGNALSTRUCT *signallistbegin[4];
   SIGNALSTRUCT *signallistend[4];	
   int dircost[4];
   RNODE *track;
   int x;
   int y;  
   bool gesperrt[4];
   bool deathend[4]; //frs umdrehen
   bool visitet[4]; //frs pathfinfing;
   int cost[4];
};

struct BAHNSTEIGNODE {
	SUPERNODE *steig[2];
	int x0,x1,y0,y1;
	BAHNSTEIGNODE *pNext;
	BAHNSTEIGNODE *pPrev;
};

class ONODE;

struct HONODE {
	HONODE *pNext;
	HONODE *pPrev;
	ONODE *oNode;
};

struct LagerNode {
	LagerNode *pNext;
	LagerNode *pPrev;
	GNODE *good;
	int amount;
};


class TSNODE
{
	public:
		TSNODE();
		 ~TSNODE();
	TSNODE *pNext;
	TSNODE *pPrev;
	int x,y;
	int hight;
	BAHNSTEIGNODE *bahnsteigfirst;
	BAHNSTEIGNODE *bahnsteiglast;
	HONODE *connectetindustriesfirst;
	HONODE *connectetindustrieslast;
	LagerNode *LagerNodeFirst;
	LagerNode *LagerNodeLast;
	void AppendLagerNode(GNODE *type);
	void AddGood(GNODE *type,int amount);
	void AppendIndustrieConnection(ONODE *oNode);	
		
	
		
	
	protected:	
};


struct FAHRPLANNODE {
	FAHRPLANNODE *pPrev;
	FAHRPLANNODE *pNext;
	bool target; // 0=supernode, 1=bahnhof
	SUPERNODE *SuperNode;
	TSNODE *tsNode;
};
struct MARSCHTABELLENNODE {
	MARSCHTABELLENNODE *pPrev;
	MARSCHTABELLENNODE *pNext;
	SUPERNODE *SuperNode;
	unsigned char dir;
};




#endif	//_TSNODE_H_

