//
// File: ZugClass.h
// Created by: chochmah <chochmah@localhost>
// Created on: Tue Sep  9 16:49:22 2003
//

#include "ZugClass.h"


ZugClass::ZugClass()
{	
	signalwatchlistfirst=0;
	belegternodespointer=0;
	neuerzug=1;
	NaechteSupernode=0;
	neuesZiel=0;
	gotoSuperNode=0;
	kachelin=0;
	kachelout=0;
	oldtracktype=0;
	ascent=0;
	descent=0;
	zielnode=0;
	neu=1;
	wagoncounter=0;
	trainlength=0;
	habeZiel=0;
	posinkachel=0;
	for (int i=0;i<40;i++) loadamount[i]=0;
}

void ZugClass::switchsignalsbehindtrain() {
	SIGNALSTRUCT *sigNode=marschtabellenpointer->SuperNode->signallistbegin[kachelin];
	while (sigNode!=0) {
		if (sigNode->indir==0) sigNode->sNode->track->signal1state=0;//ok
		if (sigNode->indir==1) sigNode->sNode->track->signal1state=0;
		if (sigNode->indir==2) sigNode->sNode->track->signal2state=0;
		if (sigNode->indir==3) sigNode->sNode->track->signal2state=0;
		sigNode=sigNode->pNext;
	}
}

void ZugClass::switchsignalsaheadoftrain() {
	SIGNALSTRUCT *sigNode=marschtabellenpointer->SuperNode->signallistbegin[(kachelin+2)%4];
	while (sigNode!=0) {
		//printf("(%i,%i) ge. von: (%i,%i) -%i- %p||",sigNode->sNode->x,sigNode->sNode->y,zNode->zug.marschtabellenpointer->SuperNode->x,zNode->zug.marschtabellenpointer->SuperNode->y,sigNode->indir,sigNode);
		if (sigNode->indir==0) sigNode->sNode->track->signal1state=1;//ok
		if (sigNode->indir==1) sigNode->sNode->track->signal1state=1;
		if (sigNode->indir==2) sigNode->sNode->track->signal2state=1;
		if (sigNode->indir==3) sigNode->sNode->track->signal2state=1;
		sigNode=sigNode->pNext;
	}
}

void ZugClass::switchsignalattrain() {
	if (kachelout<2) marschtabellenpointer->SuperNode->track->signal1state=1; 
		else marschtabellenpointer->SuperNode->track->signal2state=1;
	if (kachelout<2) marschtabellenpointer->SuperNode->track->signal2state=0; 
		else marschtabellenpointer->SuperNode->track->signal1state=0;						
}

ZugClass::~ZugClass()
{
	// TODO: put destructor code here
}

void ZugClass::AppendWagon(ObjectClass *wagon) {	
	wag[wagoncounter]=wagon;
	wagoncounter++;
	trainlength+=wagon->length;
}


 //aktion 1->2->3->4->5->6->7

void ZugClass::notifyneuerfahrplaneintrag() {
	printf("reagiere auf neuen fahrplaneintrag (aktion=%i)\n",aktion);	
	if (!habeZiel) { // wenn der zug kein ziel hat
		aktion=1; // 1 bedeutet finde weg zum nchsten supernode und markiere das als zielnode
	}
	if (aktion==2) { //zug ist ohne MTABauf dem weg zu einem punkt an dem es eine MTAB gibt
		if (zielnode==0) {
			printf("Zug ist von (%i,%i) auf dem weg in eine sackgasse\n",x,y);
		} else {
			printf("Zug ist von (%i,%i) auf dem weg zu zielnode %i %i, dort neue MTAB\n",x,y,zielnode->x,zielnode->y);
			aktion=3; //warte bis zug beim zielnode ist und berechne dann neue MTB nach Fahrplan;
		}
	}
	if (aktion==4) {
		printf("zug steht auf (%i,%i) am zielnode und braucht neue MTB\n",x,y);
		BEnode=zielnode;
		aktion=5;		
	}
	if (aktion==6) {
		printf("neue Marschtabelle berechnet jetzt marschtabelle abfahren\n");
		aktion=7;
	}
}


void ZugClass::IncPunktPointer() {
	kx[punktpointer]=rx;
	ky[punktpointer]=ry;
	kh[punktpointer]=rh;
	punktpointer++;
	if (punktpointer>trainlength) punktpointer=0;
}

void ZugClass::move() {
	float hadd,xadd,yadd;
	float v=0.071428714/2;
	int speed=10000;
	
	float zugspeed=1; //title per second
	
	float stepspertitle=20;//200000/(float)speed/zugspeed;
	float highdiff=4/stepspertitle;
	float xdiff=1/stepspertitle;
	float ydiff=1/stepspertitle;
	xadd=0;yadd=0;hadd=0;
	if ((kachelin==0)&&(kachelout==0)) xadd=xdiff;
	if ((kachelin==2)&&(kachelout==2)) xadd=-xdiff; 
	if ((kachelin==1)&&(kachelout==1)) yadd=ydiff;
	if ((kachelin==3)&&(kachelout==3)) yadd=-ydiff;
	if ((kachelin==0)&&(kachelout==3)) {yadd=-v;xadd=v;stepspertitle=14;}
	if ((kachelin==3)&&(kachelout==2)) {yadd=-v;xadd=-v;stepspertitle=14;}
	if ((kachelin==2)&&(kachelout==1)) {yadd=+v;xadd=-v;stepspertitle=14;}
	if ((kachelin==2)&&(kachelout==3)) {yadd=-v;xadd=-v;stepspertitle=14;}
	if ((kachelin==3)&&(kachelout==0)) {yadd=-v;xadd=v;stepspertitle=14;}	
	if ((kachelin==1)&&(kachelout==0)) {yadd=v;xadd=v;stepspertitle=14;}
	if ((kachelin==0)&&(kachelout==1)) {yadd=v;xadd=v;stepspertitle=14;}
	if ((kachelin==1)&&(kachelout==2)) {yadd=v;xadd=-v;stepspertitle=14;}
	if (descent) hadd=-highdiff;
	if (ascent) hadd=highdiff;	
	for (int i=0;i<stepspertitle;i++) {
		rh+=hadd;
		rx+=xadd;
		ry+=yadd;
		IncPunktPointer();
		usleep(speed);			
	}
	ascent=0;
	descent=0;
	SWNODE *swNode=signalwatchlistfirst;
	oksoweit:
	while (swNode!=0) {
		swNode->timer+=(int)stepspertitle;
		if (swNode->activ)
		if (swNode->timer+20>=trainlength) {
			//zugende durch, signale hinter dem zug auf gruen schalten
			SIGNALSTRUCT *sigNode=swNode->signal->signallistbegin[swNode->kachelin];
			while (sigNode!=0) {
				if (sigNode->indir==0) sigNode->sNode->track->signal1state=0;//ok
				if (sigNode->indir==1) sigNode->sNode->track->signal1state=0;
				if (sigNode->indir==2) sigNode->sNode->track->signal2state=0;
				if (sigNode->indir==3) sigNode->sNode->track->signal2state=0;
				sigNode=sigNode->pNext;
			}
			swNode->activ=0;
			SWNODE *t2node=swNode;
			if (swNode!=signalwatchlistfirst) {
				if (swNode!=signalwatchlistlast) {
					swNode->pPrev->pNext=swNode->pNext;
					swNode->pNext->pPrev=swNode->pPrev;																			
					swNode=t2node->pPrev;
					delete(t2node);
					goto oksoweit;				
				} else {
					swNode->pPrev->pNext=0;
					signalwatchlistlast=swNode->pPrev;										
					delete(swNode);
					return;
				}
				swNode=swNode->pPrev;
			} else {
				if (swNode!=signalwatchlistlast) {					
					swNode->pNext->pPrev=0;
				    signalwatchlistfirst=swNode->pNext;					
					swNode=t2node->pPrev;
					delete(t2node);
					goto oksoweit;				
				} else {
					signalwatchlistfirst=0;
					signalwatchlistlast=0;
					delete(swNode);
					return;
				}
			}			
			
		}
		swNode=swNode->pNext;
	}
}


bool ZugClass::signalaheadred() {
	//schau ob das signal vorraus auf rot steht
	
	MARSCHTABELLENNODE *mNode=marschtabellenpointer;
	//if (mNode!=0) 
		//if (!((mNode->SuperNode->track->signal1)||(mNode->SuperNode->track->signal2))) return(0);
	
	mNode=mNode->pPrev;
	while (mNode!=0) {
		if (((mNode->SuperNode->track->signal1)&&((mNode->SuperNode->track->signal1state)&&(mNode->dir<2)))||
			((mNode->SuperNode->track->signal2)&&((mNode->SuperNode->track->signal2state)&&(mNode->dir>=2))))
			
		{
				return(1);
			} else return(0);
		mNode=mNode->pPrev;
	}
	
	return(0);
}


void ZugClass::addsignaltowatchlist() {
	SWNODE *newNode;
	newNode = new SWNODE;
	newNode->signal=marschtabellenpointer->SuperNode;
	newNode->dir=kachelout;
	newNode->kachelin=kachelin;
	newNode->timer=0;
	newNode->activ=1;
	if (signalwatchlistfirst == 0) {
      signalwatchlistfirst = newNode;
      signalwatchlistfirst->pPrev = 0;
   	}
   	else {
      	signalwatchlistlast->pNext = newNode;
      	newNode->pPrev = signalwatchlistlast;
   	}
   	signalwatchlistlast=newNode;
   	signalwatchlistlast->pNext = 0;
}


void ZugClass::removewaypoint(int num) {
	FAHRPLANNODE *fpnode=fahrplannodefirst;
	int counter=0;
	while (fpnode!=0) {
		counter++;
		if (counter==num) {
			if (fahrplanpointer==fpnode) {
				if (fahrplanpointer->pNext==NULL) fahrplanpointer=fahrplannodefirst;
					else fahrplanpointer=fahrplanpointer->pNext;
				aktion=1;		
			}
			FAHRPLANNODE *t2node=fpnode;
			if (fpnode!=fahrplannodefirst) {
				if (fpnode!=fahrplannodelast) {
					fpnode->pPrev->pNext=fpnode->pNext;
					fpnode->pNext->pPrev=fpnode->pPrev;																			
					fpnode=t2node->pPrev;
					delete(t2node);
					//goto oksoweit;				
					return;
				} else {
					fpnode->pPrev->pNext=0;
					fahrplannodelast=fpnode->pPrev;										
					delete(fpnode);
					return;
				}
				fpnode=fpnode->pPrev;
			} else {
				if (fpnode!=fahrplannodelast) {					
					fpnode->pNext->pPrev=0;
				    fahrplannodefirst=fpnode->pNext;					
					fpnode=t2node->pPrev;
					delete(t2node);
					//goto oksoweit;				
					return;
				} else {
					fahrplannodefirst=0;
					fahrplannodelast=0;
					delete(fpnode);
					return;
				}
			}					
		}
	}
}
