//
// File: ZugClass.h
// Created by: chochmah <chochmah@localhost>
// Created on: Tue Sep  9 16:49:22 2003
//


#ifndef _ZUGCLASS_H_
#define _ZUGCLASS_H_

#include "TSNODE.h"
#include <pthread.h>
#include "ObjectClass.h"
#include "RailNetworkClass.h"

struct SWNODE {
	SWNODE *pNext;
	SWNODE *pPrev;
	SUPERNODE *signal;
	int timer;
	unsigned char dir;
	bool activ;
	unsigned char kachelin;
};


class ZugClass
{
	public:	
	ZugClass();
	 ~ZugClass();	
	
	int habeZiel;
	int aktion;
	int posinkachel;
	
	bool neu;
	bool neuerzug;
	bool NaechteSupernode;
	bool neuesZiel;
	bool gotoSuperNode;
	int kachelin;
	int kachelout;
	int oldtracktype;
	int oldtrackhight;
	bool ascent;
	bool descent;	
	SUPERNODE *BEnode; // node an der der zug ist (ab und an)
	SUPERNODE *bNode;
	SUPERNODE *zielnode;
	SUPERNODE *sNodeStart;
	int hight;
	RNODE *track;
	int punktpointer;
	float kx[2000];float ky[2000];float kh[2000];
	float rx,ry,rh;
	int x;int y;int h;
	unsigned char dir;
	FAHRPLANNODE *fahrplannodefirst;
	FAHRPLANNODE *fahrplannodelast;
	FAHRPLANNODE *fahrplanpointer;	
	MARSCHTABELLENNODE *marschtabellennodefirst;
	MARSCHTABELLENNODE *marschtabellennodelast;
	MARSCHTABELLENNODE *marschtabellenpointer;
	ObjectClass *lok;
	int trainlength;
	ObjectClass *wag[40];
	RNODE *belegternodes[40];
	int belegternodescounter;
	int belegternodespointer;
	int loadamount[40];
	int wagoncounter;	
	void AppendWagon(ObjectClass *wagon);	
	void notifyneuerfahrplaneintrag();
	void switchsignalsaheadoftrain();
	void switchsignalsbehindtrain();
	void switchsignalattrain();
	void removewaypoint(int num);
	void move();
	void IncPunktPointer();
	bool signalaheadred();
	void addsignaltowatchlist();
	protected:
	SWNODE *signalwatchlistfirst;
	SWNODE *signalwatchlistlast;
};


#endif	//_ZUGCLASS_H_
