/***************************************************************************
                          land.h  -  description
                             -------------------
    begin                : Fri Mar 1 2002
    copyright            : (C) 2002 by peterhans hendel
    email                : peterhans@dr-hendel.de
 ***************************************************************************/


#include <stdlib.h>
#include <GL/glut.h>
#include <math.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include "stdio.h"
#include "main.h"
#include "3ds.h"
#include "RailNetworkClass.h"
#include "LandClass.h"
#include "ObjectClass.h"
#include "structs2.h"


struct IndustrieListNODE {
	IndustrieListNODE *pPrev;
	IndustrieListNODE *pNext;
	ONODE *object;
};


class LandscapeClass
{
public:
int c0,c1,c2,c3;	

LandClass *Landscape;


//--------- neu

bool debugswitch;
int pathcost;
bool underwater;
RailNetworkClass *RN;
IndustrieListNODE *IndustrieListFirst;
IndustrieListNODE *IndustrieListLast;
ONODE *objpointerfirst[1024][1024];
ONODE *objpointerlast[1024][1024];
ZUGNODE *firstzug;
ZUGNODE *lastzug;


void SaveAll(char *fn);
void LoadAll(char *fn);
LandscapeClass(LandClass *land);
ZugClass *AppendZug(int x,int y,RNODE *kachel,unsigned char dir);
void AppendObject(int i,int l,ObjectClass *Objecttype,int h);	
void AddFahrplanEintrag(ZugClass *selectetzug,int x,int y,int linetoadd);
void AddFahrplanEintrag(ZugClass *selectetzug,SUPERNODE *sNode,int linetoadd);
void AddFahrplanEintrag(ZugClass *selectetzug,TSNODE *tsNode,int linetoadd);
int CalculateMarschtabelle(unsigned char dirfrom,SUPERNODE *bNode,ZugClass *zug,bool onlygreensignals);
void AddMarschtabellenEintrag(ZugClass *zug,SUPERNODE *sNode,unsigned char dir);
void DeleteMarschTabelle(ZugClass *zug);
int createMTB(unsigned char dir,ZugClass *zug,SUPERNODE *sNode,int cost,SUPERNODE *eNode,SUPERNODE *bhNode, bool onlygreensignals);
SUPERNODE *getsupernodeat(int x, int y, int z);
TSNODE *gettsnodeat(int x, int y, int z);
void Hilf(ZugClass *zug);
bool cmp(char *s1,char *s2);
void CreateTSIndustrieConnetions();
};
