//
x// File: LandscapeClass.h
// Created by: chochmah <chochmah@localhost>
// Created on: Sat Aug 30 20:01:03 2003
//

#include "LandscapeClass.h"


LandscapeClass::LandscapeClass()
{
	
}


LandscapeClass::~LandscapeClass()
{
	
}


void LandscapeClass::loadgradient(char *fn) {
	FILE *fd;
	float pos[50];
	float r[50];
	float g[50];
	float b[50];
	float x[50];
	int ms=0;
	if (NULL == (fd = fopen (fn, "r")))
	{
		printf("can't open gradient: %s", fn);
	}
	printf("loading gradient\n");
	unsigned char z;
	for (int i=0;i<1000;i++) {
		fscanf(fd,"%c",&z);
		if (z=='{') break;
	}
	fscanf(fd,"%c",&z);
	for (int i=0;i<50;i++) {
		fscanf(fd," [%f color rgbt <%f, %f, %f, %f>]\n",&pos[i],&r[i],&g[i],&b[i],&x[i]);
		if (pos[i]==1) {ms=i+1;goto ok;};
	}
	ok:
	for (int i=0;i<ms;i++)
		printf("[%f :  %f, %f, %f, %f]\n",pos[i],r[i],g[i],b[i],x[i]);
	int sx;
	sx=0;
	float e=0;
	float dx=0;float dy=0;float dz=0;
	float d=(pos[sx+1]-pos[sx])*256;
	dx=(r[sx+1]-r[sx])/d;
	dy=(g[sx+1]-g[sx])/d;
	dz=(b[sx+1]-b[sx])/d;
	for (int i=0;i<256;i++) {
		gradient[i][0]=r[sx]+dx*e;
		gradient[i][1]=g[sx]+dy*e;
		gradient[i][2]=b[sx]+dz*e;
//		printf("%i %f %f %f\n",sx,gradient[i][0],gradient[i][1],gradient[i][2]);
		e++;
		nochmal:
		if (pos[sx+1]<=(float)((float)i/256)) {
			sx++;
			e=0;
			d=(pos[sx+1]-pos[sx])*256;
			dx=(r[sx+1]-r[sx])/d;
			dy=(g[sx+1]-g[sx])/d;
			dz=(b[sx+1]-b[sx])/d;
			goto nochmal;
		}
	}
	fclose(fd);
}

void LandscapeClass::loadmap() {
	char *fn;
	FILE *fd;
	int i,l;
	unsigned char z;
	unsigned char col[256][4];
	fn = "models/map1.bmp";

	if (NULL == (fd = fopen (fn, "r")))
	{
		printf("LoadModel: Can't open this %s, ejecting!", fn);
	}
	printf("loading highmap\n");
	//read map
	//while (10 == fscanf (fd, "%c",&z))
	for (i=0;i<54;i++)
		fscanf(fd,"%c",&z);
	for (i=0;i<256;i++) {
		fscanf(fd,"%c %c %c %c",&col[i][0],&col[i][1],&col[i][2],&col[i][3]);
		printf("col %i : %i %i %i %i\n",i,col[i][0],col[i][1],col[i][2],col[i][3]); 	
	}
	for (i=0;i<381;i++)
		fscanf(fd,"%c",&z);		
	for (i=0;i<256;i++)
	for (l=0;l<256;l++)
	{
		fscanf(fd,"%c",&z);
		high[i][l]=col[z][0]-128;
		//if (high[i][l]<-40) {high[i][l]=-40;		water[i][l]=1;}

	}
	fclose(fd);
}

int highdiff(int r,int t) {
	float a=r;
	float b=t;
	float e;
	if (((a*a)-(b*b))<0) e=-1; else e=1;
		printf("%i %i,%f\n",r,t,sqrt(((a*a)-(b*b))));
	return((int)(sqrt(((a*a)-(b*b)))));
}

void LandscapeClass::setbarehigh(int x,int y,int z) {
	if ((x<SizeX)&&(x>0)&&(y<SizeY)&&(y>0)) {
	high[x][y]+=z;
	makemidpoint(x,y);
	makemidpoint(x-1,y);
	makemidpoint(x,y-1);
	makemidpoint(x-1,y-1);
	calccolor(x,y);
	calccolor(x-1,y);
	calccolor(x,y-1);
	calccolor(x-1,y-1);
	makefieldnormal(x,y);
	makefieldnormal(x-1,y);
	makefieldnormal(x,y-1);
	makefieldnormal(x-1,y-1);
	printf("highcall %i %i\n",x,y);
	}
}

void LandscapeClass::sethigh(int x,int y,int h) {
	if ((x<SizeX)&&(x>0)&&(y<SizeY)&&(y>0)) {
		bool d;
		if (high[x][y]<=h) d=1; else d=0;
		high[x][y]=h;
		for (int k=1;k<20;k++) {
			for (int i=-k;i<=k;i++) {
				if (d) {
				if (high[x+i][y-k]-high[x+i][y-k+1]<-4) setbarehigh(x+i,y-k,4);
				if (high[x+i][y+k]-high[x+i][y+k-1]<-4) setbarehigh(x+i,y+k,4);	
				if (high[x+k][y+i]-high[x+k-1][y+i]<-4) setbarehigh(x+k,y+i,4);	
				if (high[x-k][y+i]-high[x-k+1][y+i]<-4) setbarehigh(x-k,y+i,4);		
				} else {
				if (high[x+i][y-k]-high[x+i][y-k+1]>4) setbarehigh(x+i,y-k,-4);
				if (high[x+i][y+k]-high[x+i][y+k-1]>4) setbarehigh(x+i,y+k,-4);	
				if (high[x+k][y+i]-high[x+k-1][y+i]>4) setbarehigh(x+k,y+i,-4);	
				if (high[x-k][y+i]-high[x-k+1][y+i]>4) setbarehigh(x-k,y+i,-4);							
				}
			}
			if (d) {
			if (high[x+k][y+k]-high[x+k-1][y+k-1]<-8) setbarehigh(x+k,y+k,4);
			if (high[x-k][y-k]-high[x-k+1][y-k+1]<-8) setbarehigh(x-k,y-k,4);
			if (high[x-k][y+k]-high[x-k-1][y+k+1]<-8) setbarehigh(x-k,y+k,4);
			if (high[x+k][y-k]-high[x+k+1][y-k-1]<-8) setbarehigh(x+k,y-k,4);
			} else {
			if (high[x+k][y+k]-high[x+k-1][y+k-1]>8) setbarehigh(x+k,y+k,-4);
			if (high[x-k][y-k]-high[x-k+1][y-k+1]>8) setbarehigh(x-k,y-k,-4);
			if (high[x-k][y+k]-high[x-k-1][y+k+1]>8) setbarehigh(x-k,y+k,-4);
			if (high[x+k][y-k]-high[x+k+1][y-k-1]>8) setbarehigh(x+k,y-k,-4);		
			}
		}
		
	makemidpoint(x,y);
	makemidpoint(x-1,y);
	makemidpoint(x,y-1);
	makemidpoint(x-1,y-1);
	calccolor(x,y);
	calccolor(x-1,y);
	calccolor(x,y-1);
	calccolor(x-1,y-1);
	makefieldnormal(x,y);
	makefieldnormal(x-1,y);
	makefieldnormal(x,y-1);
	makefieldnormal(x-1,y-1);
	printf("highcall %i %i\n",x,y);
	} else {
		printf("SetHighcall out of range %i %i\n",x,y);
	}
}

void LandscapeClass::makediscrete() {
int k;
for (int i=0;i<256;i++)
	for (int l=0;l<256;l++)
		high[i][l]=high[i][l]-128;	
	
  
for (int i=0;i<256-1;i++)
	for (int l=0;l<256-1;l++) {
		k=0;
		if (high[i][l]>0) k=1;
	 	high[i][l]=(int)(high[i][l]/8)*4;
		if ((k==1)&&(high[i][l]==0)) high[i][l]=4;
	}

for (k=0;k<10;k++)	
for (int i=1;i<256-1;i++)
	for (int l=1;l<256-1;l++) {
		if ((high[i][l]==k*4)&&(high[i+1][l]-high[i][l]>4)) high[i+1][l]=high[i][l]+4;
	}

	
	
for (int i=0;i<256;i++)
	for (int l=0;l<256;l++)
	{        	
			if (high[i][l]>100) high[i][l]=100;
			if (high[i][l]<0) high[i][l]=0;
			if (mphigh[i][l]>100) mphigh[i][l]=100;
			if (mphigh[i][l]<0) mphigh[i][l]=0;
	}				
}

void LandscapeClass::makemidpoint(int i,int l) {
	mphigh[i][l]=(high[i][l]+high[i+1][l]+high[i][l+1]+high[i+1][l+1])/4;
	if ((high[i][l]==high[i+1][l])&&(high[i][l]==high[i+1][l+1])) mphigh[i][l]=high[i][l];		
	if ((high[i+1][l]==high[i+1][l+1])&&(high[i+1][l]==high[i][l+1])) mphigh[i][l]=high[i+1][l];
	if ((high[i][l]==high[i][l+1])&&(high[i][l]==high[i+1][l+1])) mphigh[i][l]=high[i][l];
	if ((high[i][l]==high[i+1][l])&&(high[i][l]==high[i][l+1])) mphigh[i][l]=high[i][l];
	if ((high[i][l]==high[i+1][l+1])&&(high[i+1][l]==high[i][l+1])) 
	if (high[i][l]<high[i+1][l]) mphigh[i][l]=high[i][l]; else mphigh[i][l]=high[i+1][l];
		
}

void LandscapeClass::makemidpoints() {
	for (int i=0;i<SizeX-1;i++)
	for (int l=0;l<SizeY-1;l++)
	{		
		makemidpoint(i,l);
	}
}

void LandscapeClass::loadcolormap(char *fn) {
	FILE *fd;
	int i,l;
	unsigned char  o;
	unsigned char r,g,b;
	if (NULL == (fd = fopen (fn, "r")))
	{
		printf("LoadModel: Can't open %s, ejecting!", fn);
	}
	printf("loading colormap\n");
	for (i=0;i<9;i++) {
		fscanf(fd,"%c",&r);
		}
	
	for (i=0;i<256;i++)
	for (l=0;l<256;l++)
	{
		fscanf(fd,"%c%c%c%c",&o,&b,&g,&r);
		
		for (int k=0;k<4;k++) {		
			
		col[i][l][k][0]=r;		
		col[i][l][k][1]=g;		
		col[i][l][k][2]=b;
		col[i][l][k][3]=0.3;
		col[i][l][k][0]=col[i][l][k][0]/256;		
		col[i][l][k][1]=col[i][l][k][1]/256;		
		col[i][l][k][2]=col[i][l][k][2]/256;				
		}
	}
}

void LandscapeClass::loadhighmap(char *fn) {
	FILE *fd;
	int i,l;
	unsigned char o;
	unsigned char r,g,b;
	if (NULL == (fd = fopen (fn, "r")))
	{
		printf("LoadModel: Can't open %s, ejecting!", fn);
	}
	printf("loading highmap\n");
	for (i=0;i<9;i++) {
		fscanf(fd,"%c",&r);
		}
	for (i=0;i<256;i++)
	for (l=0;l<256;l++)
	{
		fscanf(fd,"%c%c%c%c",&o,&b,&g,&r);
		high[i][l]=r;		
//		if (high[i][l]<150) high[i][l]=150;
	}
}


void LandscapeClass::SaveAll(char *fn) {
	FILE *fd;
	if (NULL == (fd = fopen (fn, "w")))
	{
		printf("can't save to file %s",fn);
	}
	fprintf(fd,"ver.: %f\n",0.1);
	fprintf(fd,"mapsize %i %i\n",SizeX,SizeY);
	fprintf(fd,"%s\n","standartgradient.pov");
	for (int i=0;i<SizeX;i++) {
		for (int l=0;l<SizeY;l++) {
			fprintf(fd,"%i %i ",high[i][l],mphigh[i][l]);
//			for (int k=0;k<4;k++) for (int m=0;m<4;m++) fprintf(fd,"%f ",col[i][l][k][m]);
		}
	}
	RNODE *rNode;
	for (int i=0;i<SizeX;i++) {
		for (int l=0;l<SizeY;l++) {
			rNode=RailTrackfirst[i][l];
			if (rNode!=0) {
				fprintf(fd,"n %i %i\n",i,l);
				while (rNode!=0) {
					fprintf(fd,"a %c %i %c %c %c\n",50+rNode->tracktype,rNode->hight,(char)rNode->signal1,(char)rNode->signal2,(char)rNode->bahnsteig);
					rNode=rNode->pNext;
				}
			}
		}
	}
	fprintf(fd,"x");
	TSNODE*tsNode;
	tsNode=firsttrainstation;
	while (tsNode!=0) {
		fprintf(fd,"s %i %i\n",tsNode->x,tsNode->y);
			BAHNSTEIGNODE *bsNode=tsNode->bahnsteigfirst;
			while(bsNode!=0) {
				fprintf(fd,"p %i %i %i %i\n",bsNode->x0,bsNode->y0,bsNode->x1,bsNode->y1);
				bsNode=bsNode->pNext;
			}
			tsNode=tsNode->pNext;
		}
			
	fprintf(fd,"x ");
	fclose(fd);
}
void LandscapeClass::LoadAll(char *fn) {	
	float Version;
	char gradientfile[100];
	FILE *fd;
	if (NULL == (fd = fopen (fn, "r")))
	{
		printf("can't load file %s",fn);
	}
	printf("loading %s\n",fn);
	fscanf(fd,"ver.: %f\n",&Version);
	fscanf(fd,"mapsize %i %i\n",&SizeX,&SizeY);
	fscanf(fd,"%s\n",&gradientfile);
	for (int i=0;i<SizeX;i++) {
		for (int l=0;l<SizeY;l++) {
			fscanf(fd,"%i %i ",&high[i][l],&mphigh[i][l]);
//			for (int k=0;k<4;k++) for (int m=0;m<4;m++) fscanf(fd,"%f ",&col[i][l][k][m]);
		}
	}
	
	char c;int x,y;
	char s1,s2;
	char bahnsteig;
	unsigned char ttype;int thight;
	while (c!='x') {
	fscanf(fd,"%c ",&c);
	if (c=='n') {
		fscanf(fd,"%i %i\n",&x,&y);
	}
	if (c=='a') {
		fscanf(fd,"%c %i %c %c %c\n",&ttype,&thight,&s1,&s2,&bahnsteig);
		ttype-=50;
		AppendTrack(x,y,ttype,thight,(bool)s1,(bool)s2,1,bahnsteig);
	}
	}
	

	int bx1,bx2,by1,by2;
	TSNODE *tsNode;
	printf("....\n");
	goto start;
	while (c!='x') {
		start:
	fscanf(fd,"%c",&c);
	if (c=='s') {
		fscanf(fd," %i %i\n",&x,&y);
		AppendObject(x,y,21,high[x][y]);
		tsNode=AppendTrainStation(x,y);
		printf("bhof appendet %i %i\n",x,y);
	}
	if (c=='p') {
		fscanf(fd," %i %i %i %i\n",&bx1,&by1,&bx2,&by2);
		AppendPlattform(tsNode,bx1,by1,bx2,by2,1);
		printf("bahnsteig appendet %i %i %i %i\n",bx1,by1,bx2,by2);
	}
	}
	
	
	loadgradient(gradientfile);	
	makefieldnormals();
	calccolors();
	fclose(fd);
}

void LandscapeClass::savetofile(char *fn) {	
	FILE *fd;
	int i,l;
	if (NULL == (fd = fopen (fn, "w")))
	{
		printf("can't write World to file");
	}
	//fprintf(fd,"%i%i\n",256,256);
	 	for (i=0;i<257;i++) for (l=0;l<257;l++)
     	fprintf(fd,"%i -",high[i][l]);

	 	for (i=0;i<257;i++) for (l=0;l<257;l++)
	 		for (int k=0;k<4;k++)
//	     	fprintf(fd,"%f -",col[i][l][k]);
	 	for (i=0;i<257;i++) for (l=0;l<257;l++)
	 	for (i=0;i<257;i++) for (l=0;l<257;l++)
     	fprintf(fd,"%i -",realhigh[i][l]);	
     	
	fclose(fd);
	printf("world saved\n");
}

void LandscapeClass::loadfromfile(char *fn) {	
	FILE *fd;
	int i,l;
	if (NULL == (fd = fopen (fn, "r")))
	{
		printf("can't open Worldfile");
	}
	printf("loading World");
//	fscanf(fd,"%i%i\n",&xw,&yw);
	 	for (i=0;i<257;i++) for (l=0;l<257;l++)
     	fscanf(fd,"%i -",&high[i][l]);
     printf(".");

	 	for (i=0;i<257;i++) for (l=0;l<257;l++)
	 		for (int k=0;k<4;k++)
//	     	fscanf(fd,"%f -",&col[i][l][k]);
   printf(".");	 	
	 	for (i=0;i<257;i++) for (l=0;l<257;l++)
   printf(".");
	 	for (i=0;i<257;i++) for (l=0;l<257;l++)
     	fscanf(fd,"%i -",&realhigh[i][l]);	

   printf(".\n");
	fclose(fd);
}

int LandscapeClass::gethigh(int a,int b) {
	if ((underwater)&&(high[a][b]<=0)) return(0);
	return high[a][b];
}
int LandscapeClass::gethight1(int a,int b) {
	if (underwater) if (watermask[a][b][0]) return(0);
	return high[a][b];
}
int LandscapeClass::gethight2(int a,int b) {
	if (underwater) if (watermask[a][b][1]) return(0);
	return high[a][b];
}
int LandscapeClass::gethight3(int a,int b) {
	if (underwater) if (watermask[a][b][2]) return(0);
	return high[a][b];
}
int LandscapeClass::gethight4(int a,int b) {
	if (underwater) if (watermask[a][b][3]) return(0);
	return high[a][b];
}
int LandscapeClass::getmphigh(int a,int b) {
return mphigh[a][b];
}
int LandscapeClass::getmphight1(int a,int b) {
	if (underwater) if (watermask[a][b][0]) return(0);
return mphigh[a][b];
}
int LandscapeClass::getmphight2(int a,int b) {
	if (underwater) if (watermask[a][b][1]) return(0);
return mphigh[a][b];
}
int LandscapeClass::getmphight3(int a,int b) {
	if (underwater) if (watermask[a][b][2]) return(0);
return mphigh[a][b];
}
int LandscapeClass::getmphight4(int a,int b) {
	if (underwater) if (watermask[a][b][3]) return(0);
return mphigh[a][b];
}

void LandscapeClass::normalize(GLfloat v[3]) {
  GLfloat d = sqrt(v[0]*v[0] + v[1]*v[1] + v[2]*v[2]);
    v[0] /= d; v[1] /= d; v[2] /= d;
}
void LandscapeClass::ncrossprod(float v1[3], float v2[3], float cp[3]) {
  cp[0] = v1[1]*v2[2] - v1[2]*v2[1];
  cp[1] = v1[2]*v2[0] - v1[0]*v2[2];
  cp[2] = v1[0]*v2[1] - v1[1]*v2[0];
  normalize(cp);
}

void LandscapeClass::triagnormal(float v1[3], float v2[3], float v3[3], float norm[3]) {
  float vec1[3], vec2[3];

  vec1[0] = v3[0] - v1[0];  vec2[0] = v2[0] - v1[0];
  vec1[1] = v3[1] - v1[1];  vec2[1] = v2[1] - v1[1];
  vec1[2] = v3[2] - v1[2];  vec2[2] = v2[2] - v1[2];

  ncrossprod(vec2, vec1, norm);
}
void LandscapeClass::triagnormald(double v1[3], double v2[3], double v3[3], float norm[3]) {
  float vec1[3], vec2[3];

  vec1[0] = v3[0] - v1[0];  vec2[0] = v2[0] - v1[0];
  vec1[1] = v3[1] - v1[1];  vec2[1] = v2[1] - v1[1];
  vec1[2] = v3[2] - v1[2];  vec2[2] = v2[2] - v1[2];

  ncrossprod(vec2, vec1, norm);
}



int pnr(int a) {
if (a != 0)
{ return rand() % a;}
else return 0;
}

void LandscapeClass::calccolor(int i, int l) {
	int h=0;
	int mh=0;	
		for (int k=0;k<4;k++) watermask[i][l][k]=0;
	if (high[i][l]>high[i+1][l]) mh=high[i][l]; else mh=high[i+1][l];
	if (high[i+1][l+1]>mh) mh=high[i+1][l+1];	
	if (high[i][l+1]>mh) mh=high[i][l+1];	
	
h=mphigh[i][l];
if (high[i][l]>h) h=high[i][l];
if (high[i+1][l]>h) h=high[i+1][l];
if (h<=0) watermask[i][l][0]=1;	
//if (h>0) h=mh;
col[i][l][0][0]=gradient[128+h][0];
col[i][l][0][1]=gradient[128+h][1];
col[i][l][0][2]=gradient[128+h][2];	


h=mphigh[i][l];
if (high[i+1][l]>h) h=high[i+1][l];
if (high[i+1][l+1]>h) h=high[i+1][l+1];
if (h<=0) watermask[i][l][1]=1;	
//if (h>0) h=mh;
col[i][l][1][0]=gradient[128+h][0];
col[i][l][1][1]=gradient[128+h][1];
col[i][l][1][2]=gradient[128+h][2];			

	
h=mphigh[i][l];
if (high[i][l+1]>h) h=high[i][l+1];
if (high[i+1][l+1]>h) h=high[i+1][l+1];
if (h<=0) watermask[i][l][2]=1;	
//if (h>0) h=mh;
col[i][l][2][0]=gradient[128+h][0];
col[i][l][2][1]=gradient[128+h][1];
col[i][l][2][2]=gradient[128+h][2];	
	
	
h=mphigh[i][l];
if (high[i][l]>h) h=high[i][l];
if (high[i][l+1]>h) h=high[i][l+1];
if (h<=0) watermask[i][l][3]=1;	
//if (h>0) h=mh;
col[i][l][3][0]=gradient[128+h][0];
col[i][l][3][1]=gradient[128+h][1];
col[i][l][3][2]=gradient[128+h][2];	

			
}

void LandscapeClass::calccolors() {
for (int i=0;i<SizeX;i++) {
	for (int l=0;l<SizeY;l++) {
		calccolor(i,l);
	}
}

/*
if ((high[i][l] ==0)&&(high[i+1][l] ==0)&&(mphigh[i][l] ==0)) {col[i][l][0][0]=0.1;col[i][l][0][1]=0.1;col[i][l][0][2]=0.7;col[i][l][0][3]=0;}
if ((high[i+1][l+1] ==0)&&(high[i+1][l] ==0)&&(mphigh[i][l] ==0)) {col[i][l][1][0]=0.1;col[i][l][1][1]=0.1;col[i][l][1][2]=0.7;col[i][l][1][3]=0;}
if ((high[i+1][l+1] ==0)&&(high[i][l+1] ==0)&&(mphigh[i][l] ==0)) {col[i][l][2][0]=0.1;col[i][l][2][1]=0.1;col[i][l][2][2]=0.7;col[i][l][2][3]=0;}
if ((high[i][l+1] ==0)&&(high[i][l] ==0)&&(mphigh[i][l] ==0)) {col[i][l][3][0]=0.1;col[i][l][3][1]=0.1;col[i][l][3][2]=0.7;col[i][l][3][3]=0;}
*/
}

void LandscapeClass::CreateNewLandscape(int sizex,int sizey) {	
	SizeX=sizex;
	SizeY=sizey;
 	int RSize;
	RSize=512; //eigenlich 1024
	int fieldwidth=RSize;	
	int mstep =11;
	int a[11];

 	int i, l;
 	int midw;
	int fieldw = fieldwidth+1;
 	int stepwide = (fieldw-1)*2; 				
 	float stepnum = 0.5;
	int sd = 100;
	int globstep;
	srand((unsigned int) time(NULL));
	
	high[0][0] = 20;
	high[RSize][RSize] = 20;
	high[0][RSize] = 20;
	high[RSize][0] = 20;

	for (i=0;i<11;i++) a[i] = 0;

    a[0] = 20;
	a[1] = 0;
	a[2] = 0;
	a[3] = 0;
	a[4] = 4;
	a[5] = 4;
	a[6] = 2;
	a[7] = 5;
    a[8] = 5;
    a[9] = 0;
	a[10] = 0;
    a[11] = 0;
	

	for (globstep=1; globstep < mstep;globstep++)
 		{
 		//sd = sd/2;
		sd = a[globstep-1];
 		stepwide = (stepwide/2);
 		stepnum = stepnum*2; 							
 		//* find and set midpoints *//
 		for (i=0; i<stepnum;i++)
 			{
 			for (l=0; l<stepnum;l++)
 				{ 										
 				midw = (high[stepwide*i][stepwide*l]+high[stepwide*(i+1)][stepwide*l]+high[stepwide*(i+1)][stepwide*(l+1)]+high[stepwide*i][stepwide*(l+1)])/4;
 				high[stepwide*i+stepwide/2][stepwide*l+stepwide/2] = midw+ pnr(sd)-sd/2;
 				}
 			}
 		//* task and set bordervalues *//
 		for  (i=0; i<stepnum;i++)
 			{
 			//* upper border*//
 			midw = (high[stepwide*i][0]+high[stepwide*(i+1)][0]+high[stepwide*i+stepwide/2][stepwide/2])/3;
 			high[stepwide*i+stepwide/2][0] = midw+ pnr(sd)-sd/2;
 			//* down border*//
			midw = (high[stepwide*i][fieldw-1]+high[stepwide*(i+1)][fieldw-1]+high[stepwide*i+stepwide/2][fieldw-1-stepwide/2])/3;
 			high[stepwide*i+stepwide/2][fieldw-1] = midw+ pnr(sd)-sd/2;
			//* left border*//
			midw = (high[0][stepwide*i]+high[0][stepwide*(i+1)]+high[stepwide/2][stepwide*i+stepwide/2])/3;
 			high[0][stepwide*i+stepwide/2] = midw+ pnr(sd)-sd/2;
 			//* right border*//
 			midw = (high[fieldw-1][stepwide*i]+high[fieldw-1][stepwide*(i+1)]+high[fieldw-1-stepwide/2][stepwide*i+stepwide/2])/3;
 			high[fieldw-1][stepwide*i+stepwide/2] = midw+ pnr(sd)-sd/2;
 			}
 		//* task and set midpoints on the lines *//
 		//*first order points*//
 		for (i=0; i<stepnum;i++)
 			{
 			for (l=0; l<stepnum-1;l++)
 				{
 				midw = (high[stepwide*i][stepwide*l+stepwide]+high[stepwide*(i+1)][stepwide*l+stepwide]+high[stepwide*i+stepwide/2][stepwide*l+stepwide/2]+high[stepwide*i+stepwide/2][stepwide*l+stepwide+stepwide/2])/4;
 				high[stepwide*i+stepwide/2][stepwide*l+stepwide] = midw+ pnr(sd)-sd/2;
 				}
			}
		//*second order points*//
		for (i=0; i<stepnum-1;i++)
			{
			for (l=0; l<stepnum;l++)
 				{
 				midw = (high[stepwide*i+stepwide/2][stepwide*l]+high[stepwide*i+stepwide+stepwide/2][stepwide*l+stepwide/2]+high[stepwide*i+stepwide][stepwide*l]+high[stepwide*i+stepwide][stepwide*(l+1)])/4;
 				high[stepwide*i+stepwide][stepwide*l+stepwide/2] = midw+ pnr(sd)-sd/2;
 				}
			}						
		}

for (int k=0;k<1;k++)
for (i=1;i<RSize-1;i++)
	for (l=1;l<RSize-1;l++)
	{
		high[i][l]=(high[i][l]+high[i+1][l]+high[i][l+1]+high[i+1][l+1])/4;
	}

for (i=0;i<RSize-1;i++)
	for (l=0;l<RSize-1;l++)
	 high[i][l]=(int)(high[i][l]/4)*4;
	

for (i=0;i<RSize-1;i++)
	for (l=0;l<RSize-1;l++)
	{
		mphigh[i][l]=(high[i][l]+high[i+1][l]+high[i][l+1]+high[i+1][l+1])/4;
	}
  for (i=0;i<RSize;i++)
	for (l=0;l<RSize;l++)
	{     
/*		
			if (high[i][l]>100) high[i][l]=100;
			if (high[i][l]<0) high[i][l]=0;
			if (mphigh[i][l]>100) mphigh[i][l]=100;
			if (mphigh[i][l]<0) mphigh[i][l]=0;
*/
	}
	
}


void LandscapeClass::makeRiver(int i, int l) {
if ((i==0) || (l==0) || (i==250) || (l==250))
{
} else
{
	/*
water[i][l]=1;
if ((high[i][l] <= high[i+1][l]) &&
    (high[i][l] <= high[i][l+1]) &&
    (high[i][l] <= high[i-1][l]) &&
    (high[i][l] <= high[i+1][l-1])) {high[i][l]++;}
if (high[i][l] > high[i+1][l]) {makeRiver(i+1,l);}
if (high[i][l] > high[i-1][l]) {makeRiver(i-1,l);}
if (high[i][l] > high[i][l+1]) {makeRiver(i,l+1);}
if (high[i][l] > high[i][l-1]) {makeRiver(i,l-1);}
	*/
}
	
}

void LandscapeClass::makefieldnormal(int i,int l) {
  GLfloat v1[3];
  GLfloat v2[3];
  GLfloat v3[3];
  GLfloat v4[3];
  GLfloat v5[3]; 
  int hsizex = SizeX/2;
  int hsizey = SizeY/2;  
  	v1[0] = 0+i-hsizex;v1[1]=0+l-hsizey;v1[2] = high[i][l]*0.07;
	v2[0] = 1+i-hsizex;v2[1]=0+l-hsizey;v2[2] = high[i+1][l]*0.07;
	v3[0] = 1+i-hsizex;v3[1]=1+l-hsizey;v3[2] = high[i+1][l+1]*0.07;
	v4[0] = 0+i-hsizex;v4[1]=1+l-hsizey;v4[2] = high[i][l+1]*0.07;
	v5[0] = 0.5+i-hsizex;v5[1]=0.5+l-hsizey;v5[2] = mphigh[i][l]*0.07;
	triagnormal(v1, v2, v5, highnorm[i][l][0]);
    triagnormal(v5, v2, v3, highnorm[i][l][1]);
	triagnormal(v3, v4, v5, highnorm[i][l][2]);
   triagnormal(v4, v1, v5, highnorm[i][l][3]);	
}

void LandscapeClass::makefieldnormals() {
  GLfloat v1[3];
  GLfloat v2[3];
  GLfloat v3[3];
  GLfloat v4[3];
  GLfloat v5[3]; 
  int hsizex = SizeX/2;
  int hsizey = SizeY/2;  
  int i,l;
  for (i=0;i<SizeX-1;i++)
	for (l=0;l<SizeY-1;l++)
	{

	v1[0] = 0+i-hsizex;v1[1]=0+l-hsizey;v1[2] = high[i][l]*0.07;
	v2[0] = 1+i-hsizex;v2[1]=0+l-hsizey;v2[2] = high[i+1][l]*0.07;
	v3[0] = 1+i-hsizex;v3[1]=1+l-hsizey;v3[2] = high[i+1][l+1]*0.07;
	v4[0] = 0+i-hsizex;v4[1]=1+l-hsizey;v4[2] = high[i][l+1]*0.07;
	v5[0] = 0.5+i-hsizex;v5[1]=0.5+l-hsizey;v5[2] = mphigh[i][l]*0.07;
	triagnormal(v1, v2, v5, highnorm[i][l][0]);
    triagnormal(v5, v2, v3, highnorm[i][l][1]);
	triagnormal(v3, v4, v5, highnorm[i][l][2]);
	triagnormal(v4, v1, v5, highnorm[i][l][3]);
   }
}

GLfloat *LandscapeClass::gethighnorm(int a,int b, int f) {
	if ((underwater)&&(watermask[a][b][f])) return(vhighnorm);
	return(highnorm[a][b][f]);	
}
