//
// File: TextBubbelClass.h
// Created by: chochmah <chochmah@mitre.localhost.localdomain>
// Created on: Tue Dec 16 20:56:06 2003
//

#include "TextBubbelClass.h"
#include <stdio.h>
#include <stdlib.h>
#include <limits.h>           /* ULONG_MAX is defined here */
#include <float.h>            /* FLT_MAX is atleast defined here */
#include "unistd.h"

extern int fieldposx;
extern int fieldposy;
extern int SWidth;
extern int SHeight;
extern float Highscale;
extern bool isdrawing;
extern bool isappending;

TextBubbelClass::TextBubbelClass()
{
	textnodefirst=0;
}


TextBubbelClass::~TextBubbelClass()
{
	// TODO: put destructor code here
}


void TextBubbelClass::AppendText(char *text,int x,int y,int h, float r, float g, float b) {
	while (isdrawing) {usleep(100);};
	isappending=1;	
	//printf("glproj: %f %f %f %f %f %f auf %i %i %i\n",rx,ry,rz,(float)wx,(float)wy,(float)wz,x,y,h);
	TNODE *newNode;
	newNode = new TNODE;
	newNode->x=x;
	newNode->y=y;
	newNode->h=h;
	newNode->timer=0;
	newNode->newhere=1;
	newNode->r=r;
	newNode->g=g;
	newNode->b=b;
	for (int i=0;i<30;i++)
		newNode->text[i]=text[i];
	
   if (textnodefirst == 0) {
      textnodefirst = newNode;
      textnodefirst->pPrev = 0;
   }
   else {
      textnodelast->pNext = newNode;
      newNode->pPrev = textnodelast;
   }   
   textnodelast=newNode;
   textnodelast->pNext = 0;
   isappending=0;
}
void TextBubbelClass::ticker() {	
	if (!isdrawing) {
	TNODE *tnode=textnodefirst;
	oksoweit:
	while (tnode!=0) {		
		tnode->timer+=2;				
		if(tnode->timer>=40) {
			TNODE *t2node=tnode;
			if (tnode!=textnodefirst) {
				if (tnode!=textnodelast) {
					tnode->pPrev->pNext=tnode->pNext;
					tnode->pNext->pPrev=tnode->pPrev;																			
					tnode=t2node->pPrev;
					delete(t2node);
					goto oksoweit;				
				} else {
					tnode->pPrev->pNext=0;
					textnodelast=tnode->pPrev;										
					delete(tnode);
					return;
				}
				tnode=tnode->pPrev;
			} else {
				if (tnode!=textnodelast) {					
					tnode->pNext->pPrev=0;
				    textnodefirst=tnode->pNext;					
					tnode=t2node->pPrev;
					delete(t2node);
					goto oksoweit;				
				} else {
					textnodefirst=0;
					textnodelast=0;
					delete(tnode);
					return;
				}
			}			
		}		
		tnode=tnode->pNext;
	}	
	}
}


void TextBubbelClass::BProject(TNODE *tnode) {
	GLdouble wx, wy, wz;
	GLint viewport[4];
  	GLdouble mvmatrix[16], projmatrix[16];
 	
	glGetIntegerv (GL_VIEWPORT, viewport);
    glGetDoublev (GL_MODELVIEW_MATRIX, mvmatrix);
    glGetDoublev (GL_PROJECTION_MATRIX, projmatrix);
	  
	

	gluProject(tnode->x-fieldposx,tnode->h*Highscale,tnode->y-fieldposy,mvmatrix, projmatrix, viewport, &wx, &wy, &wz);		
	wx=wx/SWidth;
	wy=wy/SHeight;	
	tnode->sx=wx;
	tnode->sy=wy;
	tnode->newhere=0;
}
