//
// File: TextBubbelClass.h
// Created by: chochmah <chochmah@mitre.localhost.localdomain>
// Created on: Tue Dec 16 20:56:06 2003
//

#ifndef _TEXTBUBBELCLASS_H_
#define _TEXTBUBBELCLASS_H_

#include <GL/gl.h>	// Header File For The OpenGL32 Library
#include <GL/glu.h>	// Header File For The GLu32 Library


struct TNODE {
	TNODE *pNext;
	TNODE *pPrev;
	GLfloat sx,sy;
	float r,g,b;
	int x,y,h;
	char text[30];
	int timer;
	bool newhere;
};


class TextBubbelClass
{
	public:
		TextBubbelClass();
		 ~TextBubbelClass();
		void AppendText(char *text,int x, int y,int h,float r,float g,float b);
		void BProject(TNODE *tnode);
		void ticker();
		TNODE *textnodefirst;
		TNODE *textnodelast;
	
	protected:			
	
};


#endif	//_TEXTBUBBELCLASS_H_

