#include "land.h"
#include "ZugClass.h"
#include <pthread.h>
#include <limits.h> 
#include <float.h>  
#include "unistd.h"
#include "ONODE.h"
#include "ObjectClass.h"


extern ObjectClass *objectclasslistfirst;
extern ObjectClass *objectclasslistlast;


bool LandscapeClass::cmp(char *s1,char *s2) {
int i=0;
	while ((s1[i]!='\0')||(s2[i]!='\0')) {
		//printf("[%c,%c]",s1[i],s2[i]);
		if (s1[i]!=s2[i]) return 0;
		i++;
	}
	return(1);
}



extern bool AmSpeichern;
extern void (createthread)(int x);
extern ObjectClass *hcm[100];

int LandscapeClass::createMTB(unsigned char dir,ZugClass *zug,SUPERNODE *sNode,int cost,SUPERNODE *eNode,SUPERNODE *bhnode,bool onlygreensignals) {
	SUPERNODE *sxNode=RN->supernodelistfirst;
	int m=0;
	while (sxNode!=0) {
		if (sxNode==sNode) m=1;					
		sxNode=sxNode->pNext;
	}
	if (m==0) printf("error....!!!\n");

	//printf("yo %i %i\n",sNode->visitet,visitetmode);
	/*
	printf("im loop\n");
	if (sNode==0) {printf("ERROR snode=0\n");return(0);}
	printf("dir: %i\n",dir);
	for (int i=0;i<4;i++) {
		if (i==dir) printf("->");
		printf("visitet %i - %i\n",i,sNode->visitet[i]);
	}
	*/	

		
	if ((sNode->visitet[dir]!=RN->visitetmode)||
		((sNode->visitet[dir]==RN->visitetmode)&&(sNode->cost[dir]>cost))) {			
		sNode->visitet[dir]=RN->visitetmode;
		sNode->cost[dir]=cost;
		cost++;
		if (onlygreensignals) {
			if (dir<2)
				if ((sNode->track->signal1)&&(sNode->track->signal1state)) {pathcost+=20;}
			else 
				if ((sNode->track->signal2)&&(sNode->track->signal2state)) {pathcost+=20;}
		}
		
		
		//printf("<%i>SNODE::%i %i %i %i %i %i\n",dir,sNode->x,sNode->y,sNode->sdir[0],sNode->sdir[1],sNode->sdir[2],sNode->sdir[3]);
		if ((sNode==eNode)) {
			bool z=0;
			for (int k=0;k<4;k++) if (sNode->visitet[k]==RN->visitetmode) if (sNode->cost[dir]>sNode->cost[k]) z=1;
			if (z==0) {
				//printf("path gefunden %i\n",cost);
				DeleteMarschTabelle(zug);
				pathcost=0;
				if (bhnode!=0) {
					AddMarschtabellenEintrag(zug,bhnode,0);
					AddMarschtabellenEintrag(zug,sNode,(dir+2)%4);
				} else AddMarschtabellenEintrag(zug,sNode,0);
				return(1);
			}
		}		
		if (dir==10) { //node an dem die suche gestartet wird;
			int t=5;
			for (int k=0;k<4;k++) {			
				if ((sNode->dir[k][0])&&(!sNode->deathend[0])&&(!sNode->gesperrt[0])) if (createMTB(sNode->sdir[0],zug,sNode->dir[k][0],cost,eNode,bhnode,onlygreensignals)) t=0;			
				if ((sNode->dir[k][1])&&(!sNode->deathend[1])&&(!sNode->gesperrt[1])) if (createMTB(sNode->sdir[1],zug,sNode->dir[k][1],cost,eNode,bhnode,onlygreensignals)) t=1;			
				if ((sNode->dir[k][2])&&(!sNode->deathend[2])&&(!sNode->gesperrt[2])) if (createMTB(sNode->sdir[2],zug,sNode->dir[k][2],cost,eNode,bhnode,onlygreensignals)) t=2;			
				if ((sNode->dir[k][3])&&(!sNode->deathend[3])&&(!sNode->gesperrt[3])) if (createMTB(sNode->sdir[3],zug,sNode->dir[k][3],cost,eNode,bhnode,onlygreensignals)) t=3;
			}
			//printf("k==....%i\n",t);
			if (t!=5) {AddMarschtabellenEintrag(zug,sNode,t);return(1);}	
		} else {
			unsigned char richtung=5;
			richtung=dir;
			//printf("richting: %i\n",richtung);
			if (richtung==5) printf("ERROR\n");
			int t=5;
	
			if ((sNode->dir[richtung][0])&&(!sNode->deathend[0])&&(!sNode->gesperrt[0])) {/*printf("von %i nach 0 cost %i\n",richtung,cost);*/if (createMTB(sNode->sdir[0],zug,sNode->dir[richtung][0],cost,eNode,bhnode,onlygreensignals)) t=0;}
			if ((sNode->dir[richtung][1])&&(!sNode->deathend[1])&&(!sNode->gesperrt[1])) {/*printf("von %i nach 1 cost %i\n",richtung,cost);*/if (createMTB(sNode->sdir[1],zug,sNode->dir[richtung][1],cost,eNode,bhnode,onlygreensignals)) t=1;}
			if ((sNode->dir[richtung][2])&&(!sNode->deathend[2])&&(!sNode->gesperrt[2])) {/*printf("von %i nach 2 cost %i\n",richtung,cost);*/if (createMTB(sNode->sdir[2],zug,sNode->dir[richtung][2],cost,eNode,bhnode,onlygreensignals)) t=2;}
			if ((sNode->dir[richtung][3])&&(!sNode->deathend[3])&&(!sNode->gesperrt[3])) {/*printf("von %i nach 3 cost %i\n",richtung,cost);*/if (createMTB(sNode->sdir[3],zug,sNode->dir[richtung][3],cost,eNode,bhnode,onlygreensignals)) t=3;}	
			if (t!=5) {AddMarschtabellenEintrag(zug,sNode,t);pathcost++;return(1);}			
		}
	}
	return(0);	
}


int LandscapeClass::CalculateMarschtabelle(unsigned char dirfrom,SUPERNODE *bNode, ZugClass *zug,bool onlygreensignals) {

	//sicherheitsprfung:
	
	printf("->berechne neue marschtabelle\n");
	if (bNode==0) printf("error: bnode=0\n");
	DeleteMarschTabelle(zug);
	bool isstation=0;	
	SUPERNODE *sNode=0;
	SUPERNODE *vNode;
	if (zug->fahrplanpointer->target==0) 
		sNode=zug->fahrplanpointer->SuperNode;
	if (zug->fahrplanpointer->target==1) 
		isstation=1;
	int oldpathcost=0;
	SUPERNODE *bestpath=0;
	SUPERNODE *bestpathbnode=0;
	int cost=0;
	int cost2=30000;
	pathcost=0;	
	if (!isstation) {cost = createMTB(dirfrom,zug,bNode,0,sNode,0,onlygreensignals);if (cost==0) return(0);}
	if (isstation) {
		TSNODE *tsNode=zug->fahrplanpointer->tsNode;
		BAHNSTEIGNODE *bsNode=tsNode->bahnsteigfirst;
		oldpathcost=300000;
		while (bsNode!=0) {
			for (int i=0;i<2;i++) {				
				pathcost=0;
				cost2=0;
				cost2 = createMTB(dirfrom,zug,bNode,0,bsNode->steig[i],0,onlygreensignals);
				if ((pathcost<oldpathcost)&&(cost2==1)) {
					printf("yo");
					oldpathcost=pathcost;
					bestpath=bsNode->steig[i];
					if (i==0) bestpathbnode=bsNode->steig[1];
					if (i==1) bestpathbnode=bsNode->steig[0];
					}
				printf("path: %i,pathcost:%i\n",cost2,pathcost);
				vNode=RN->supernodelistfirst;
				while (vNode!=0) {
					for (int k=0;k<4;k++) vNode->visitet[k]=RN->visitetmode;
					vNode=vNode->pNext;
				}
				RN->visitetmode=!RN->visitetmode;
			}
			bsNode= bsNode->pNext;
		}
	cost = createMTB(dirfrom,zug,bNode,0,bestpath,bestpathbnode,onlygreensignals);			
	printf("optimal: %i\n",pathcost);
	}		
	sNode=RN->supernodelistfirst;
	while (sNode!=0) {
		for (int k=0;k<4;k++) sNode->visitet[k]=RN->visitetmode;
		sNode=sNode->pNext;
	}
	RN->visitetmode=!RN->visitetmode;
	/*
	MARSCHTABELLENNODE *xNode=zug->marschtabellennodefirst;	
	while (xNode!=0) {
		printf("%i %i %i\n",xNode->SuperNode->x,xNode->SuperNode->y,xNode->dir);
		xNode=xNode->pNext;
	}
	*/	
	return(cost);	
}

void LandscapeClass::AddMarschtabellenEintrag(ZugClass *zug,SUPERNODE *sNode,unsigned char dir) {
	//printf("seach %i %i\n",sNode->x,sNode->y);
	MARSCHTABELLENNODE *newNode;
	newNode = new MARSCHTABELLENNODE;
	newNode->SuperNode=sNode;
	newNode->dir=dir;
	if (zug->marschtabellennodefirst == 0) {
      zug->marschtabellennodefirst = newNode;
      zug->marschtabellennodefirst->pPrev = 0;
   }
   else {
      zug->marschtabellennodelast->pNext = newNode;
      newNode->pPrev = zug->marschtabellennodelast;
   }
   zug->marschtabellennodelast=newNode;
   zug->marschtabellennodelast->pNext = 0;
   //printf("Marschtabelleneintrag: zug %p node %p %i %i %i\n",&zug,sNode,sNode->x,sNode->y,dir);
}

void LandscapeClass::AddFahrplanEintrag(ZugClass *selectetzug,SUPERNODE *sNode,int linetoadd) {
	FAHRPLANNODE *newNode;
	newNode = new FAHRPLANNODE;
	newNode->target=0;
	newNode->tsNode=0;
	newNode->SuperNode=sNode;
	
	if (linetoadd==0) {
		if (selectetzug->fahrplannodefirst == 0) {
    	  selectetzug->fahrplannodefirst = newNode;
    	  selectetzug->fahrplannodefirst->pPrev = 0;
		  selectetzug->fahrplanpointer=newNode; //frs erste wird dem zug beim ersten eintrag der eintrag als ziel gesetzt
   	}
   	else {
   	   selectetzug->fahrplannodelast->pNext = newNode;
   	   newNode->pPrev = selectetzug->fahrplannodelast;
   	}
	   selectetzug->fahrplannodelast=newNode;
   		selectetzug->fahrplannodelast->pNext = 0;
   } else {
	   int counter=0;
	   FAHRPLANNODE *nNode=selectetzug->fahrplannodefirst;
	   while(nNode!=0) {
		   counter++;
		   if (linetoadd==counter) {
			FAHRPLANNODE *dNode=nNode->pNext;   
		    nNode->pNext=newNode;
			newNode->pPrev=nNode;
			if (nNode!=selectetzug->fahrplannodelast) {
				newNode->pNext=dNode;
				dNode->pPrev=newNode;
			} else {
				newNode->pNext=0;
				selectetzug->fahrplannodelast=newNode;
			}
			   
		   }
		   nNode=nNode->pNext;
	   }
   }
   
   printf("Fahrplaneintrag fr: zug %p an node %p\n",selectetzug,sNode);
   selectetzug->notifyneuerfahrplaneintrag();
}

void LandscapeClass::AddFahrplanEintrag(ZugClass *selectetzug,TSNODE *tsNode,int linetoadd) {
	FAHRPLANNODE *newNode;
	newNode = new FAHRPLANNODE;
	newNode->target=1;
	newNode->tsNode=tsNode;
	newNode->SuperNode=RN->supernodelistfirst;
	if (linetoadd==0) {
	printf("Bahnhof an fahrplan appendet\n");
	if (selectetzug->fahrplannodefirst == 0) {
      selectetzug->fahrplannodefirst = newNode;
      selectetzug->fahrplannodefirst->pPrev = 0;
	  selectetzug->fahrplanpointer=newNode; //frs erste wird dem zug beim ersten eintrag der eintrag als ziel gesetzt
   }
   else {
      selectetzug->fahrplannodelast->pNext = newNode;
      newNode->pPrev = selectetzug->fahrplannodelast;
   }
   selectetzug->fahrplannodelast=newNode;
   selectetzug->fahrplannodelast->pNext = 0;
   } else {
	   int counter=0;
	   FAHRPLANNODE *nNode=selectetzug->fahrplannodefirst;
	   while(nNode!=0) {
		   counter++;
		   if (linetoadd==counter) {
			FAHRPLANNODE *dNode=nNode->pNext;   
		    nNode->pNext=newNode;
			newNode->pPrev=nNode;
			if (nNode!=selectetzug->fahrplannodelast) {
				newNode->pNext=dNode;
				dNode->pPrev=newNode;
			} else {
				newNode->pNext=0;
				selectetzug->fahrplannodelast=newNode;
			}
			   
		   }
		   nNode=nNode->pNext;
	   }
   }
}

void LandscapeClass::AddFahrplanEintrag(ZugClass *selectetzug,int x,int y,int linetoadd) {
	TSNODE *tsNode;
	tsNode=RN->firsttrainstation;
	while (tsNode!=0) {		
		if ((tsNode->x==x)&&(tsNode->y==y)) {
			printf("bahnhof select %i %i\n",x,y);
			AddFahrplanEintrag(selectetzug,tsNode,linetoadd);
			return;
		}
		tsNode=tsNode->pNext;
	}
	
	SUPERNODE *sNode;
	sNode=RN->supernodelistfirst;
	while (sNode!=0) {
		if ((sNode->x==x)&&(sNode->y==y)) {
			AddFahrplanEintrag(selectetzug,sNode,linetoadd);
		}
		sNode=sNode->pNext;
	}
}

void LandscapeClass::DeleteMarschTabelle(ZugClass *zug) {
	MARSCHTABELLENNODE *sNode=zug->marschtabellennodefirst;
	MARSCHTABELLENNODE *nNode;
	while (sNode!=0) {
		nNode=sNode->pNext;
		delete(sNode);
		sNode=nNode;
	}
	zug->marschtabellennodefirst=0;
	zug->marschtabellennodelast=0;		
}





void LandscapeClass::Hilf(ZugClass *zug) {
	for (int i=0;i<2000;i++) {
		zug->kx[i]=zug->x+1;
		zug->ky[i]=zug->y+0.5;
		zug->kh[i]=zug->hight;
	}
	zug->rx=zug->x+1;
	zug->ry=zug->y+0.5;	
	zug->rh=zug->hight;
	zug->oldtrackhight=zug->hight;
	zug->punktpointer=0;
	zug->hight=Landscape->Bgethigh(zug->x,zug->y);
	
}
ZugClass *LandscapeClass::AppendZug(int x,int y,RNODE *kachel,unsigned char dir) {
	ZUGNODE *newNode;
	newNode = new ZUGNODE;
	newNode->zug.x=x;
	newNode->zug.y=y;
	newNode->zug.rx=x+0.5;
	newNode->zug.ry=y+0.5;
	newNode->zug.hight=Landscape->Bgethigh(x,y);
	for (int i=0;i<2000;i++) {  //vorlufig
		newNode->zug.kx[i]=x+0.5;
		newNode->zug.ky[i]=y+0.50;
	}
	newNode->zug.punktpointer=0;
	newNode->zug.dir=dir;
	newNode->zug.track=kachel;
	newNode->zug.marschtabellenpointer=0;
	newNode->zug.fahrplanpointer=0;
	newNode->zug.h=kachel->hight;
	newNode->zug.fahrplannodefirst=0;
	newNode->zug.fahrplannodelast=0;
	newNode->zug.marschtabellennodefirst=0;
	newNode->zug.marschtabellennodelast=0;
	
	
	
	
	if (firstzug == 0) {
      firstzug = newNode;
      firstzug->pPrev = 0;
   }
   else {
      lastzug->pNext = newNode;
      newNode->pPrev = lastzug;
   }
   lastzug=newNode;
   lastzug->pNext = 0;
   printf("zug appendet %i %i %i\n",x,y,dir);
   return(&newNode->zug);
}



void LandscapeClass::AppendObject(int i,int l,ObjectClass *Objecttype,int h) {
	ONODE *newNode;
	newNode = new ONODE;
	newNode->Objecttype=Objecttype;
	newNode->hight=h;
	newNode->x=i;
	newNode->y=l;
	if (objpointerfirst[i][l] == 0) {
      objpointerfirst[i][l] = newNode;
      objpointerfirst[i][l]->pPrev = 0;
   }
   else {
      objpointerlast[i][l]->pNext = newNode;
      newNode->pPrev = objpointerlast[i][l];
   }
   objpointerlast[i][l]=newNode;
   objpointerlast[i][l]->pNext = 0;
   if (cmp(Objecttype->type,"industrie")) { //industrie zu globaler Industrieliste hinzufgen
	IndustrieListNODE *iNode;
	iNode = new IndustrieListNODE;
	iNode->object=newNode;
	if (IndustrieListFirst == 0) {
      IndustrieListFirst = iNode;
      IndustrieListFirst->pPrev = 0;
   }
   else {
      IndustrieListLast->pNext = iNode;
      iNode->pPrev = IndustrieListLast;
   }
   IndustrieListLast=iNode;
   IndustrieListLast->pNext = 0;   
	   
   }
   
}



LandscapeClass::LandscapeClass(LandClass *land) {
	Landscape=land;
	firstzug=0;
	lastzug=0;
	
for (int i=0;i<512;i++)
	for (int l=0;l<512;l++) {
		objpointerfirst[i][l]=0;
		Landscape->watermask[i][l][0]=0;
		Landscape->watermask[i][l][1]=0;
		Landscape->watermask[i][l][2]=0;
		Landscape->watermask[i][l][3]=0;		
	}
Landscape->vhighnorm[0]=0;
Landscape->vhighnorm[1]=0;
Landscape->vhighnorm[2]=1;
Landscape->debugswitch=0;
}


void LandscapeClass::SaveAll(char *fn) {
	AmSpeichern=1;
	usleep(2000000);
	FILE *fd;
	
	if (NULL == (fd = fopen ("zugsave", "w")))
	{
		printf("can't save to file %s",fn);
	} 
	ZUGNODE *zNode=firstzug;
	while (zNode!=0) {
		fprintf(fd,"s");
		printf("saving zug\n");
		fprintf(fd,"%i %i %i\n",zNode->zug.x,zNode->zug.y,zNode->zug.hight);
		fprintf(fd,"%i\n",zNode->zug.dir);
		fprintf(fd,"%i\n",zNode->zug.aktion);				
		fprintf(fd,"%f %f %f\n",zNode->zug.rx,zNode->zug.ry,zNode->zug.rh);
		fprintf(fd,"%i\n",zNode->zug.oldtrackhight);
		fprintf(fd,"%i\n",zNode->zug.oldtracktype);
		fprintf(fd,"%i\n",zNode->zug.punktpointer);
		fprintf(fd,"%i %i %i\n",zNode->zug.zielnode->x,zNode->zug.zielnode->y,zNode->zug.zielnode->track->hight);
		fprintf(fd,"%i\n",zNode->zug.habeZiel);
		fprintf(fd,"%i %i\n",zNode->zug.kachelin,zNode->zug.kachelout);
		fprintf(fd,"%i %i %i\n",zNode->zug.BEnode->x,zNode->zug.BEnode->y,zNode->zug.BEnode->track->hight);		
		fprintf(fd,"%i %i\n",zNode->zug.neuesZiel,zNode->zug.NaechteSupernode);
		//marschtabelle speichern.
		int mtpointer=0;
		int i=0;
		MARSCHTABELLENNODE *mtabNode=zNode->zug.marschtabellennodefirst;
		while (mtabNode!=0) {			
			i++;
			if (mtabNode==zNode->zug.marschtabellenpointer) mtpointer=i;
			fprintf(fd,"m %i %i %i %i\n",mtabNode->dir,mtabNode->SuperNode->x,mtabNode->SuperNode->y,mtabNode->SuperNode->track->hight);
			printf("m %i %i %i %i %p\n",mtabNode->dir,mtabNode->SuperNode->x,mtabNode->SuperNode->y,mtabNode->SuperNode->track->hight,mtabNode->SuperNode);
			mtabNode=mtabNode->pNext;
		}
		fprintf(fd,"x");
		//fahrplan speichern
		int fppointer=0;
		int l=0;
		FAHRPLANNODE *fpNode=zNode->zug.fahrplannodefirst;				
		while (fpNode!=0) {						
			l++;
			if (fpNode==zNode->zug.fahrplanpointer) fppointer=l;
			if (fpNode->target==0) {									
					fprintf(fd,"f 0 %i %i %i\n",fpNode->SuperNode->x,fpNode->SuperNode->y,fpNode->SuperNode->track->hight);
				}
			if (fpNode->target==1) {					
					fprintf(fd,"f 1 %i %i %i\n",fpNode->tsNode->x,fpNode->tsNode->y,fpNode->tsNode->hight);
				}				
			fpNode=fpNode->pNext;
		}
		fprintf(fd,"x");		
		fprintf(fd,"%i\n",mtpointer);
		fprintf(fd,"%i\n",fppointer);
		
		for (int i=0;i<2000;i++) {
			fprintf(fd,"k %f %f %f\n",zNode->zug.kx[i],zNode->zug.ky[i],zNode->zug.kh[i]);
		}		
		for (int i=0;i<40;i++) {
			if (zNode->zug.wag[i])
				fprintf(fd,"%s\n",zNode->zug.wag[i]->objectname);
			else fprintf(fd,"%s\n","NULL");
		}
		
		zNode=zNode->pNext;
	}	
	fprintf(fd,"x");
	fclose(fd);
	
	if (NULL == (fd = fopen (fn, "w")))
	{
		printf("can't save to file %s",fn);
	}
	fprintf(fd,"ver.: %f\n",0.1);
	fprintf(fd,"mapsize %i %i\n",Landscape->SizeX,Landscape->SizeY);
	fprintf(fd,"%s\n","standartgradient.pov");
	for (int i=0;i<Landscape->SizeX;i++) {
		for (int l=0;l<Landscape->SizeY;l++) {
			fprintf(fd,"%i %i ",Landscape->Bgethigh(i,l),Landscape->mphigh[i][l]);
//			for (int k=0;k<4;k++) for (int m=0;m<4;m++) fprintf(fd,"%f ",col[i][l][k][m]);
		}
	}
	RNODE *rNode;
	
	for (int i=0;i<Landscape->SizeX;i++) {
		for (int l=0;l<Landscape->SizeY;l++) {
			ONODE *oNode = objpointerfirst[i][l];
			if (oNode!=0) {
				fprintf(fd,"n %i %i\n",i,l);
				while (oNode!=0) {
					fprintf(fd,"a %i %s\n",oNode->hight,oNode->Objecttype->objectname);				
					oNode=oNode->pNext;
				}
			}
		}
	}
	fprintf(fd,"x ");
	for (int i=0;i<Landscape->SizeX;i++) {
		for (int l=0;l<Landscape->SizeY;l++) {
			rNode=RN->RailTrackfirst[i][l];
			if (rNode!=0) {
				fprintf(fd,"n %i %i\n",i,l);
				while (rNode!=0) {
					fprintf(fd,"a %c %i %c %c %c %c %c\n",50+rNode->tracktype,rNode->hight,(char)rNode->signal1,(char)rNode->signal2,(char)rNode->bahnsteig,(char)rNode->signal1state,(char)rNode->signal2state);
					rNode=rNode->pNext;
				}
			}
		}
	}
	fprintf(fd,"x");
	TSNODE*tsNode;
	tsNode=RN->firsttrainstation;
	while (tsNode!=0) {
		fprintf(fd,"s %i %i\n",tsNode->x,tsNode->y);
			BAHNSTEIGNODE *bsNode=tsNode->bahnsteigfirst;
			while(bsNode!=0) {
				fprintf(fd,"p %i %i %i %i\n",bsNode->x0,bsNode->y0,bsNode->x1,bsNode->y1);
				bsNode=bsNode->pNext;
			}
			tsNode=tsNode->pNext;
		}
			
	fprintf(fd,"x ");
	fclose(fd);
	AmSpeichern=0;
}

SUPERNODE *LandscapeClass::getsupernodeat(int x, int y, int z) {
	SUPERNODE *sNode=RN->supernodelistfirst;	
	while (sNode!=0) {				
		//printf("snode: %i %i %i\n",sNode->x,sNode->y,sNode->track->hight);
		if ((sNode->x==x)&&(sNode->y==y)&&(sNode->track->hight==z)) return(sNode);
		sNode=sNode->pNext;
	}
	printf("error! snode nicht gefunden\n");
	return(0);	
}

TSNODE *LandscapeClass::gettsnodeat(int x, int y, int z) {
	TSNODE *tsNode=RN->firsttrainstation;
	while (tsNode!=0) {				
		//printf("--tsnode: %i %i %i\n",tsNode->x,tsNode->y,tsNode->hight);
		if ((tsNode->x==x)&&(tsNode->y==y)) return(tsNode);
		tsNode=tsNode->pNext;
	}
	printf("error! tsnode nicht gefunden\n");
	return(0);	
}


void LandscapeClass::LoadAll(char *fn) {	
	FILE *fd;
	float Version;
	char gradientfile[100];	
	if (NULL == (fd = fopen (fn, "r")))
	{
		printf("can't load file %s",fn);
	}
	printf("loading %s\n",fn);
	fscanf(fd,"ver.: %f\n",&Version);
	fscanf(fd,"mapsize %i %i\n",&Landscape->SizeX,&Landscape->SizeY);
	fscanf(fd,"%s\n",&gradientfile);
	for (int i=0;i<Landscape->SizeX;i++) {
		for (int l=0;l<Landscape->SizeY;l++) {
			int h;
			fscanf(fd,"%i %i ",&h,&Landscape->mphigh[i][l]);
			Landscape->Bsethigh(i,l,h);
//			for (int k=0;k<4;k++) for (int m=0;m<4;m++) fscanf(fd,"%f ",&col[i][l][k][m]);
		}
	}
	
	char c;int x,y,h;
	char s1,s2,s1s,s2s;
	char name[100];
	while (c!='x') {
	fscanf(fd,"%c ",&c);
	if (c=='n') {
		fscanf(fd,"%i %i\n",&x,&y);
	}
	if (c=='a') {
		fscanf(fd,"%i %s\n",&h,&name);				
		ObjectClass *oNode=objectclasslistfirst;
		int t=0;
		while (oNode!=0) {
			if (cmp(name,oNode->objectname)) {AppendObject(x,y,oNode,h);t=1;}
			oNode=oNode->pNext;
		}		
		if (!t) printf("FATAL ERROR 312, object %s could not be found while loading %s\n",name,fn);
		}
	}
	c='m';
	char bahnsteig;
	unsigned char ttype;int thight;
	while (c!='x') {
	fscanf(fd,"%c ",&c);
	if (c=='n') {
		fscanf(fd,"%i %i\n",&x,&y);
	}
	if (c=='a') {
		fscanf(fd,"%c %i %c %c %c %c %c\n",&ttype,&thight,&s1,&s2,&bahnsteig,&s1s,&s2s);
		ttype-=50;
		//RN->AppendTrack(x,y,ttype,thight,(bool)s1,(bool)s2,1,bahnsteig,(bool)s1s,(bool)s2s);
		RN->AppendTrack(x,y,ttype,thight,(bool)s1,(bool)s2,1,bahnsteig,0,0);
		Landscape->bebaut[x][y]=1;
	}
	}
	

	int bx1,bx2,by1,by2;
	TSNODE *tsNode=0;	
	goto start;
	while (c!='x') {
		start:
	fscanf(fd,"%c",&c);
	if (c=='s') {
		fscanf(fd," %i %i\n",&x,&y);		
		tsNode=RN->AppendTrainStation(x,y,Landscape->Bgethigh(x,y));
		//printf("bhof appendet %i %i\n",x,y);
	}
	if (c=='p') {
		fscanf(fd," %i %i %i %i\n",&bx1,&by1,&bx2,&by2);
		RN->AppendPlattform(tsNode,bx1,by1,bx2,by2,1);
		//printf("bahnsteig appendet %i %i %i %i\n",bx1,by1,bx2,by2);
	}
	}
	
	
	Landscape->loadgradient(gradientfile);	
	Landscape->makefieldnormals();
	Landscape->calccolors();	
	RN->BuildSuperNodeList(Landscape->SizeX,Landscape->SizeY);
	RN->BuildSignalNetwork();
	fclose(fd);	
	
	
	if (1) {
	if (NULL == (fd = fopen ("zugsave", "r")))
	{
		printf("can't open file %s",fn);
	} else {
	int t=0;
	char c3;
	fscanf(fd,"%c ",&c3);	
	while (c3!='x') {		
	int h;
	int dir;	
	ZugClass *zug=0;
	fscanf(fd,"%i %i %i\n",&x,&y,&h);	
	fscanf(fd,"%i\n",&dir);
	zug=AppendZug(x,y,RN->RailTrackfirst[x][y],dir);	
	zug->hight=h;
	fscanf(fd,"%i\n",&zug->aktion);		
	fscanf(fd,"%f %f %f\n",&zug->rx,&zug->ry,&zug->rh);
	fscanf(fd,"%i\n",&zug->oldtrackhight);
	fscanf(fd,"%i\n",&zug->oldtracktype);
	fscanf(fd,"%i\n",&zug->punktpointer);
	fscanf(fd,"%i %i %i\n",&x,&y,&h);
	zug->zielnode=getsupernodeat(x,y,h);
	fscanf(fd,"%i\n",&zug->habeZiel);
	fscanf(fd,"%i %i\n",&zug->kachelin,&zug->kachelout);
	fscanf(fd,"%i %i %i\n",&x,&y,&h);
	zug->BEnode=getsupernodeat(x,y,h);
	
	int d;
	char c2='m';
	while (c2!='x') {
	fscanf(fd,"%c ",&c2);
		if (c2=='m') {
			fscanf(fd," %i %i %i %i\n",&d, &x,&y,&h);							
			//printf("%p\n",getsupernodeat(x,y,h));			
			AddMarschtabellenEintrag(zug,getsupernodeat(x,y,h),d);
		}
	}
	int type;
	goto start2;
	while (c2!='x') {
	start2:
	fscanf(fd,"%c ",&c2);
		if (c2=='f') {
			fscanf(fd," %i %i %i %i\n",&type,&x,&y,&h);				
			//printf("fp->%i %i %i %i\n",type,x,y,h);
			if (type==0) AddFahrplanEintrag(zug,getsupernodeat(x,y,h),0);
			if (type==1) AddFahrplanEintrag(zug,gettsnodeat(x,y,h),0);			
		}
	}
			
	int l=0;
	int mtpointernum;
	fscanf(fd,"%i\n",&mtpointernum);
	MARSCHTABELLENNODE *mtNODE=zug->marschtabellennodefirst;
	while (mtNODE!=0) {
		l++;
		if (l==mtpointernum) zug->marschtabellenpointer=mtNODE;
		mtNODE=mtNODE->pNext;
	}
	l=0;
	int fppointernum;
	fscanf(fd,"%i\n",&fppointernum);
	FAHRPLANNODE *fpNode=zug->fahrplannodefirst;
	while (fpNode!=0) {
		l++;
		if (l==fppointernum) {zug->fahrplanpointer=fpNode;printf("fppointer=%i\n",l);}
		fpNode=fpNode->pNext;
	}
	
	for (int i=0;i<2000;i++) {		
			fscanf(fd,"k %f %f %f\n",&zug->kx[i],&zug->ky[i],&zug->kh[i]);
			//printf("%f %f %f\n",zug->kx[i],zug->ky[i],zug->kh[i]);
	}
	char name[100];
	for (int i=0;i<40;i++) {			
		fscanf(fd,"%s\n",name);			
		if (!cmp(name,"NULL")) {
			ObjectClass *oNode=objectclasslistfirst;
			while (oNode!=0) {
				if (cmp(name,oNode->objectname)) zug->AppendWagon(oNode);						 	
				oNode=oNode->pNext;
			}			
		}
	}
	createthread(t);	
	t++;
	fscanf(fd,"%c ",&c3);	
	//printf("--->%c\n",c3);
	}
	fclose(fd);
}
}

}

void LandscapeClass::CreateTSIndustrieConnetions() {
	TSNODE *tsNode=RN->firsttrainstation;
	while (tsNode!=0) {
		int x=tsNode->x;
		int y=tsNode->y;
		for (int i=x-20;i<x+20;i++) {			
			for (int l=y-20;l<y+20;l++) {
				if ((i>0)&&(l>0)&&(i<Landscape->SizeX)&&(l<Landscape->SizeY)) {
					ONODE *oNode=objpointerfirst[i][l];
					while (oNode!=0) {						
						if (cmp(oNode->Objecttype->type,"industrie")) {
							tsNode->AppendIndustrieConnection(oNode);			
							oNode->AppendTSConnection(tsNode);							
						}
						oNode=oNode->pNext;
					}							
				}
			}
		}
		tsNode=tsNode->pNext;
	}
}


