#ifndef _STRUCTS_H_
#define _STRUCTS_H_

#include "TSNODE.h"

struct SUPERNODE;

struct GNODE {
	GNODE *pNext;
   	GNODE *pPrev;
	char name[50];
	int pays;
};
struct RNODE {
   RNODE *pNext;
   RNODE *pPrev;
   unsigned char tracktype;
   int hight;
   //Signalcode	
   bool signal1;
   bool signal2;
   bool signal1state;
   bool signal2state;
   bool bahnsteig;
};


struct SIGNALSTRUCT {
	SIGNALSTRUCT *pNext;
	SIGNALSTRUCT *pPrev;
	SUPERNODE *sNode;
	int indir;
};

struct SUPERNODE {
   SUPERNODE *pNext;
   SUPERNODE *pPrev;
   SUPERNODE *dir[4][4];
   
   unsigned char sdir[4];
   SIGNALSTRUCT *signallistbegin[4];
   SIGNALSTRUCT *signallistend[4];	
   int dircost[4];
   RNODE *track;
   int x;
   int y;  
   bool deathend[4]; //frs umdrehen
   bool visitet[4]; //frs pathfinfing;
   int cost[4];
};

struct BAHNSTEIGNODE {
	SUPERNODE *steig[2];
	int x0,x1,y0,y1;
	BAHNSTEIGNODE *pNext;
	BAHNSTEIGNODE *pPrev;
};


struct FAHRPLANNODE {
	FAHRPLANNODE *pPrev;
	FAHRPLANNODE *pNext;
	bool target; // 0=supernode, 1=bahnhof
	SUPERNODE *SuperNode;
	TSNODE *tsNode;
};
struct MARSCHTABELLENNODE {
	MARSCHTABELLENNODE *pPrev;
	MARSCHTABELLENNODE *pNext;
	SUPERNODE *SuperNode;
	unsigned char dir;
};

#endif	
