//
// File: testwindow.h
// Created by: chochmah <chochmah@localhost>
// Created on: Fri Jan 16 02:46:31 2004
//



#include <FL/fl_draw.H>
#include "testwindow.h"

void testwindow::draw() {
#ifdef DEBUG
  printf("%s : draw\n",label());
#endif
  Fl_Window::draw();
  if (key) fl_draw(&key, 1, cx, cy);
}

int testwindow::handle(int e) {
#ifdef DEBUG
//  if (e != FL_MOVE) printf("%s : %s\n",label(),eventnames[e]);
#endif
  if (Fl_Window::handle(e)) return 1;
  if (e == FL_FOCUS) return 1;
  if (e == FL_PUSH) {Fl::focus(this); return 1;}
  if (e == FL_KEYBOARD && Fl::event_text()[0]) {
    key = Fl::event_text()[0];
    cx = Fl::event_x();
    cy = Fl::event_y();
    redraw();
    return 1;
  }
  return 0;
}
